local TOCNAME,BOM=...
local L = setmetatable({}, {__index = function (t, k)  
	if BOM.L and BOM.L[k] then 
		return BOM.L[k]
	else
		return "["..k.."]"
	end	
end})
BUFFOMAT_ADDON=BOM

--[[

-todo

I NEED FEEDBACK! I can't test this code for Paladin / Hunter / Druid
(Blessings-, Auras- and Aspect-handling. Druid "Track Humanoids" while in cat.)

0.90
- new TABs on main window
- Tab Buff - old "Main"-window
- Tab Spells - configuration of every spell
Icons from left to right: on/off, all/self, on classes, Always on Person X (current target!)
This settings are stored per character!
Simple click on a icon to toogle!

0.80
- fix bug in blessing
- druid-buffs include a "/cancelform"
- add fearward


0.71
- Mage Armor-Spells use now "Seals"-Mechanik, only one can be active
- Aura - track only casted by player
- Add Paladin-Seals - default off


0.70
- new Tracking-Detection. Always want to cast the last active tracking.
- Track Humanoids (as cat) -> more tests needed!
- Paladin/Hunter/Druid -> more tests needed!


0.60
- update-check-Optimizations
- Reset "HasResurrection"-Check after combat
- new Message "somebody is dead"
- Group buff only, when everybody is in range
- Error-Message, when macro can't created
- Option "Only in same zone" - for example when in raid are persons without the prequest.
- Add druid-buff "Omen of Clarity"

0.50
- Repair hasResurrection detection - should not resurrect somebody which has already resurrected
- Option "Only buff self"
- Option "Ignore in raid group x"

0.40
- Chinese translation by wellcat
- add "Find Treasure" tracking spell
- fallback resurrection, try to resurrect a "ghost"-player
- Use now Rank and better spell-detection

0.30 
- resurrection optimizations
- buff handling optimizations
- fix bug with mages
- bug fixes

0.20
- repair distance-check (list) / Sort order List
- Wait for SPELLS_CHANGED Event before scanning for spells
- party update only on special events
- Option "Don't use group buff"
- minimap-button indicates now missing buffs
- better combat - detection / indicates
- disable button while global cool-down
- disable button while casting
- disable button while combat
- many small changes and bug fixes

0.10
- first release

-- TODO
- about


]]--

--BOM.IsDebug=true

BOM.Version=GetAddOnMetadata(TOCNAME, "Version") 
BOM.Title=GetAddOnMetadata(TOCNAME, "Title") 

BOM.Icon="Ability_Druid_ChallangingRoar"
BOM.IconOff="Ability_Druid_DemoralizingRoar"
BOM.FullIcon="Interface\\ICONS\\Ability_Druid_ChallangingRoar"
BOM.TxtEscapeIcon="|T%s:0:0:0:0:64:64:4:60:4:60|t"
BOM.TxtEscapePicture="|T%s:0|t"
BOM.MSGPREFIX="BOM: "
BOM.MACRONAME="Buff'o'mat"
BOM.MAXACCOUNTMACROS=36
BOM.MAXCHARACTERMACROS=18
BOM.BLESSINGID="blessing"


--"UNIT_POWER_UPDATE","UNIT_SPELLCAST_START","UNIT_SPELLCAST_STOP","PLAYER_STARTED_MOVING","PLAYER_STOPPED_MOVING"
local CombatEvent={"PLAYER_REGEN_ENABLED", "PLAYER_REGEN_DISABLED", "PLAYER_ENTER_COMBAT", "PLAYER_LEAVE_COMBAT"}
local UpdateOnEvent={"UPDATE_SHAPESHIFT_FORM", "UNIT_AURA", "PLAYER_ENTERING_WORLD", "READY_CHECK", "LOADING_SCREEN_DISABLED",  "PLAYER_ALIVE", "PLAYER_UNGHOST", "INCOMING_RESURRECT_CHANGED"}
local PartyChangeEvent={ "GROUP_JOINED", "GROUP_ROSTER_UPDATE", "RAID_ROSTER_UPDATE","GROUP_LEFT"}
local SpellChangedEvent={"SPELLS_CHANGED","LEARNED_SPELL_IN_TAB"}

local function PopupDB(db,var)
	return L["Cbox"..var],false,db,var
end

function BOM.Popup(self,minimap)
	if not BOM.PopupDynamic:Wipe((self:GetName() or "nil")..(minimap and "Minimap" or "Normal")) then
		return 
	end
	
	if minimap then
		BOM.PopupDynamic:AddItem(L.BtnOpen,false,BOM.ShowWindow)
		BOM.PopupDynamic:AddItem()
	end
	
	for i,spell in ipairs(BOM.Spells) do 
		BOM.PopupDynamic:AddItem(spell.singleLink or spell.single,"keep",BOM.DBChar.Spell[spell.ConfigID],"Enable")
	end
	

	BOM.PopupDynamic:AddItem()
	BOM.PopupDynamic:AddItem(L["Cboxshowminimapbutton"],false,BOM.DB.Minimap,"visible")
	BOM.PopupDynamic:AddItem(L["CboxLockMinimapButton"],false,BOM.DB.Minimap,"lock")
	BOM.PopupDynamic:AddItem(L["CboxLockMinimapButtonDistance"],false,BOM.DB.Minimap,"lockDistance")
	BOM.PopupDynamic:AddItem()
	BOM.PopupDynamic:AddItem(PopupDB(BOM.DB,"AutoOpen"))
	BOM.PopupDynamic:AddItem(PopupDB(BOM.DB,"DeathBlock"))
	BOM.PopupDynamic:AddItem(PopupDB(BOM.DB,"NoGroupBuff"))
	BOM.PopupDynamic:AddItem(PopupDB(BOM.DB,"SameZone"))
	BOM.PopupDynamic:AddItem()
	BOM.PopupDynamic:SubMenu(L["HeaderIgnoreGroup"],"subGroup")
	
	local usable=true
	if IsInRaid() then 
		usable="keep"
	end	
	for i=1,8 do
		BOM.PopupDynamic:AddItem(i,usable,BOM.IgnoreGroup,i)
	end
	BOM.PopupDynamic:SubMenu()
	
	BOM.PopupDynamic:AddItem()
	BOM.PopupDynamic:AddItem(L.BtnSettings,false,BOM.Options.Open,BOM.Options)
	BOM.PopupDynamic:AddItem()
	BOM.PopupDynamic:AddItem(L["BtnCancel"],false)
	
	
	BOM.PopupDynamic:Show(self or "cursor",0,0)
end

function BOM.BtnClose()
	BOM.HideWindow()
end

function BOM.BtnSettings(self)
	BOM.Popup(self)
end

function BOM.BtnMacro()
	PickupMacro(BOM.MACRONAME)
end

function BOM.ScrollMessage(self,delta)
	self:SetScrollOffset(self:GetScrollOffset() + delta*5);
	self:ResetAllFadeTimes()
end

function BOM.OptionsUpdate()
	BOM.UpdateScan()
	BOM.UpdateSpells()
	BOM.MinimapButton:UpdatePosition()
	BOM.Options:DoCancel() 
end

local function BOM_CheckBox(Var,Init)
	BOM.Options:AddCheckBox(BOM.DB,Var,Init,L["Cbox"..Var])
end


local SpellCheckboxs,SpellTexts
function BOM.OptionsInit()
	BOM.Options.Init(
		function()-- doOk
			BOM.Options:DoOk() 
			BOM.OptionsUpdate()
		end,
		function()-- doCancel
			BOM.Options:DoCancel() 
			BOM.OptionsUpdate()
		end,
		function()--doDefault
			BOM.Options:DoDefault() 
			BOM.DB.Minimap.position=50
			BOM.ResetWindow()			
			BOM.OptionsUpdate()
		end
		)
	BOM.Options:AddPanel(BOM.Title)
	BOM.Options:AddVersion('|cff00c0ff' .. BOM.Version .. "|r")
	
	BOM.Options:AddCheckBox(BOM.DB.Minimap,"visible",true,L["Cboxshowminimapbutton"])
	BOM.Options:AddCheckBox(BOM.DB.Minimap,"lock",false,L["CboxLockMinimapButton"])
	BOM.Options:AddCheckBox(BOM.DB.Minimap,"lockDistance",false,L["CboxLockMinimapButtonDistance"])
	BOM.Options:AddSpace()
	BOM_CheckBox("AutoOpen",true)
	BOM_CheckBox("DeathBlock",true)
	BOM_CheckBox("NoGroupBuff",false)
	BOM_CheckBox("SameZone",false)
	BOM.Options:AddSpace()
	
	SpellCheckboxs={}
	for i=0,20 do 
		tinsert(SpellCheckboxs, BOM.Options:AddCheckBox(nil,nil,nil,"") )
	end
	
	BOM.Options:AddPanel(L.PanelSupportedSpells,false,true)
	BOM.Options:Indent(10)
	--local txt=""
	
	SpellTexts={}
	for i,spell in ipairs(BOM.SpellList) do
		if type(spell)=="table" then
			SpellTexts[i]=BOM.Options:AddText("<placeholder>")			
		else
			BOM.Options:Indent(-10)
			if LOCALIZED_CLASS_NAMES_MALE [spell] then
				BOM.Options:AddCategory(LOCALIZED_CLASS_NAMES_MALE[spell])
			else
				BOM.Options:AddCategory(L["Header_"..spell])
			end
			BOM.Options:Indent(10)
		end
	end
	
	local function SlashText(txt)
		BOM.Options:AddText(txt)
	end
	
	BOM.Options:AddPanel(L["PanelAbout"])

	BOM.Options:AddCategory("|cFFFF1C1C"..GetAddOnMetadata(TOCNAME, "Title") .." ".. GetAddOnMetadata(TOCNAME, "Version") .." by "..GetAddOnMetadata(TOCNAME, "Author"))
	BOM.Options:Indent(10)
	BOM.Options:AddText(GetAddOnMetadata(TOCNAME, "Notes"))		
	BOM.Options:Indent(-10)
	
	BOM.Options:AddCategory(L["HeaderInfo"])
	BOM.Options:Indent(10)
	BOM.Options:AddText(L["AboutInfo"],-20)
	BOM.Options:Indent(-10)
	
	BOM.Options:AddCategory(L["HeaderUsage"])
	BOM.Options:Indent(10)
	BOM.Options:AddText(L["AboutUsage"],-20)
	BOM.Options:Indent(-10)
	
	BOM.Options:AddCategory(L["HeaderSlashCommand"])
	BOM.Options:Indent(10)
	BOM.Options:AddText(L["AboutSlashCommand"],-20)
	BOM.Tool.PrintSlashCommand(nil,nil,SlashText)
	BOM.Options:Indent(-10)
	
	BOM.Options:AddCategory(L["HeaderCredits"])
	BOM.Options:Indent(10)
	BOM.Options:AddText(L["AboutCredits"],-20)
	BOM.Options:Indent(-10)
	
	
	
end

function BOM.OptionsInsertSpells()
	for i,cbox in ipairs(SpellCheckboxs) do 
		cbox:Hide()
	end
	
	
	for i,spell in ipairs(BOM.Spells) do 
		BOM.Options:EditCheckBox(SpellCheckboxs[i],BOM.DBChar.Spell[spell.ConfigID],"Enable", spell.default, spell.singleLink or spell.single)
	end
	
	for i,spell in ipairs(BOM.SpellList) do
		if type(spell)=="table" then
			if spell.groupId then
				BOM.Options:EditText(SpellTexts[i],(spell.singleLink or spell.single).." / "..(spell.groupLink or spell.group))
			else
				BOM.Options:EditText(SpellTexts[i],(spell.singleLink or spell.single or spell.ConfigID))
			end
		end
	end
	
	
	--BOM.DB.DEBUGTXT=txt
	BOM.UpdateSpells()
	BOM.UpdateScan()
end


function BOM.Init()
	function SetDefault(db,var,init)
		if db[var]==nil then db[var]=init end
	end

	if not buffOmatDB then buffOmatDB = {} end
	if not buffOmatDB.Minimap then buffOmatDB.Minimap = {} end
	if not buffOmatDBChar then buffOmatDBChar = {} end
	
	if not buffOmatDBChar.Blessing then buffOmatDBChar.Blessing = {} end
	-- delete old settings
	buffOmatDBChar.Spells=nil
	
	BOM.DB=buffOmatDB
	BOM.DBChar=buffOmatDBChar
	
	local x, y, w, h = BOM.DB.X, BOM.DB.Y, BOM.DB.Width, BOM.DB.Height	
	if not x or not y or not w or not h then
		BOM.SaveWindowPosition()
	else
		BuffOmat_MainWindow:ClearAllPoints()
		BuffOmat_MainWindow:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y)
		BuffOmat_MainWindow:SetWidth(w)
		BuffOmat_MainWindow:SetHeight(h)
	end
	
	BOM.Tool.EnableSize(BuffOmat_MainWindow,8,nil,function() BOM.SaveWindowPosition()	end)
	
	-- slash command
	local function doDBSet(DB,var,value)
		if value==nil then
			DB[var]= not DB[var]
		elseif tContains({"true","1","enable"},value) then
			DB[var]=true
		elseif tContains({"false","0","disable"},value) then
			DB[var]=false
		end
		DEFAULT_CHAT_FRAME:AddMessage(BOM.MSGPREFIX.."Set "..var.." to "..tostring(DB[var]))
		BOM.OptionsUpdate()
	end
	BOM.Tool.SlashCommand({"/bom","/buffomat"},{
		{"debug","",{
				{"buff","",BOM.DebugBuffs},
			},
		},
		{"spellbook",L["SlashSpellBook"],BOM.GetSpells},
		{"update",L["SlashUpdate"],BOM.UpdateScan},
		{"close",L["SlashClose"],BOM.HideWindow},
		{"reset",L["SlashReset"],BOM.ResetWindow},
		{"",L["SlashOpen"],BOM.ShowWindow},
	})
	
	BuffOmat_ListTab_MessageFrame:SetFading(false);
	--if RollTrackerClassicDB.LootTracker.SmallFont then
		BuffOmat_ListTab_MessageFrame:SetFontObject(GameFontNormalSmall);
	--else
	--	BuffOmat_ListTab_MessageFrame:SetFontObject(GameFontNormal);
	--end
	BuffOmat_ListTab_MessageFrame:SetJustifyH("LEFT");
	BuffOmat_ListTab_MessageFrame:SetHyperlinksEnabled(true);
	--BuffOmat_ListTab_MessageFrame:SetTextCopyable(true);
	BuffOmat_ListTab_MessageFrame:Clear()
	BuffOmat_ListTab_MessageFrame:SetMaxLines(100)
	
	BuffOmat_ListTab_Button:SetAttribute("type", "macro")
	BuffOmat_ListTab_Button:SetAttribute("macro", BOM.MACRONAME)	

	BOM.Tool.OnUpdate(BOM.UpdateTimer)
	
	BOM.PopupDynamic=BOM.Tool.CreatePopup(BOM.OptionsUpdate)
		
	BOM.MinimapButton.Init(BOM.DB.Minimap,BOM.FullIcon,
		function(self,button)
			if button=="LeftButton" then 
				BOM.ToggleWindow()
			else
				BOM.Popup(self.button,true)
			end
		end
		,BOM.Title)	
	
	BuffOmat_MainWindow_Title:SetText(string.format(BOM.TxtEscapeIcon,BOM.FullIcon).." "..BOM.Title)
	--BuffOmat_ListTab_Button:SetText(L["BtnGetMacro"])
	
	BOM.OptionsInit()
	BOM.PartyUpdateNeeded=true
	BOM.RepeatUpdate=false
	
	BOM.Tool.EnableMoving(BuffOmat_MainWindow,BOM.SaveWindowPosition)
	
	BuffOmat_MainWindow:SetMinResize(150,75)
	
	BOM.Tool.AddTab(BuffOmat_MainWindow,L.TabBuff,BuffOmat_ListTab)
	BOM.Tool.AddTab(BuffOmat_MainWindow,L.TabSpells,BuffOmat_SpellTab)
	BOM.Tool.SelectTab(BuffOmat_MainWindow,1)
	
	BOM.IgnoreGroup={}
end

local LastUpdateTimer
function BOM.UpdateTimer()

	if BOM.CheckCoolDown then
		local cdtest=GetSpellCooldown(BOM.CheckCoolDown)
		if cdtest==0 then
			BOM.CheckCoolDown=nil
			BOM.UpdateScan()
		end
	end

	if (BOM.ForceUpdate or (BOM.RepeatUpdate and BOM.IsMoving)) and  LastUpdateTimer~=time() then
		BOM.UpdateScan()
		
		LastUpdateTimer=time()
		--print("forced update",time())
	end
end


local function Event_ADDON_LOADED(arg1)
	if arg1 == TOCNAME then
		BOM.Init()
	end
	BOM.Tool.AddDataBrocker(BOM.FullIcon, 
		function(self,button)
			if button=="LeftButton" then 
				BOM.ToggleWindow()
			else
				BOM.Popup(self,true)
			end
		end)
end

local function Event_UNIT_POWER_UPDATE(arg1,arg2)
	--UNIT_POWER_UPDATE: "unitTarget", "powerType"
	if arg2=="MANA" and UnitIsUnit(arg1, "player") then
		if (BOM.ManaLimit or 0)<=(UnitPower("player",0) or 0) then
			BOM.ForceUpdate=true
		end
	end
end

local function Event_GenericUpdate()
	BOM.ForceUpdate=true
end

local function Event_SpellsChanged()
	BOM.GetSpells()
	BOM.ForceUpdate=true
	BOM.CreateSpellTab=false
	BOM.OptionsInsertSpells()
end

local function Event_PartyChanged()
	BOM.PartyUpdateNeeded=true
	BOM.ForceUpdate=true
end

local function Event_UNIT_SPELLCAST_START(uid)
	if UnitIsPlayer(uid) then
		--print("casting")
		BOM.PlayerCasting=true
		BOM.ForceUpdate=true
	end
end

local function Event_UNIT_SPELLCAST_STOP(uid)
	if UnitIsPlayer(uid) then
		--print("endcasting")
		BOM.PlayerCasting=false
		BOM.ForceUpdate=true
	end
end

local function Event_PLAYER_STARTED_MOVING()
	BOM.ForceUpdate=BOM.RepeatUpdate
	BOM.IsMoving=true
end

local function Event_PLAYER_STOPPED_MOVING()
	BOM.ForceUpdate=BOM.RepeatUpdate
	BOM.IsMoving=false
end

local function Event_Combat()
	BOM.ForceUpdate=true
	BOM.DeclineResurrection=true
end

local function Event_PLAYER_TARGET_CHANGED()
	if not InCombatLockdown() then
		if UnitInParty("target") or UnitInRaid("target") or UnitIsUnit("target","player") then
			BOM.lastTarget=(UnitFullName("target"))
			BOM.UpdateSpells()
		elseif BOM.lastTarget then
			BOM.lastTarget=nil
			BOM.UpdateSpells()			
		end
	end
	--print("target:",BOM.lastTarget)
end

function BOM.OnLoad()
	--print("internal load")

	BOM.Tool.RegisterEvent("ADDON_LOADED",Event_ADDON_LOADED)
	BOM.Tool.RegisterEvent("UNIT_POWER_UPDATE",Event_UNIT_POWER_UPDATE)
	BOM.Tool.RegisterEvent("UNIT_SPELLCAST_START",Event_UNIT_SPELLCAST_START)
	BOM.Tool.RegisterEvent("UNIT_SPELLCAST_STOP",Event_UNIT_SPELLCAST_STOP)
	BOM.Tool.RegisterEvent("PLAYER_STARTED_MOVING",Event_PLAYER_STARTED_MOVING)
	BOM.Tool.RegisterEvent("PLAYER_STOPPED_MOVING",Event_PLAYER_STOPPED_MOVING)
	BOM.Tool.RegisterEvent("PLAYER_TARGET_CHANGED",Event_PLAYER_TARGET_CHANGED)
	for i,event in ipairs(CombatEvent) do 
		BOM.Tool.RegisterEvent(event,Event_Combat)
	end
	for i,event in ipairs(SpellChangedEvent) do
		BOM.Tool.RegisterEvent(event,Event_SpellsChanged)
	end
	for i,event in ipairs(PartyChangeEvent) do
		BOM.Tool.RegisterEvent(event,Event_PartyChanged)
	end
	for i,event in ipairs(UpdateOnEvent) do
		BOM.Tool.RegisterEvent(event,Event_GenericUpdate)
	end
	
end

function BOM.HideWindow()
	if not InCombatLockdown() then
		BuffOmat_MainWindow:Hide()
	end
end

function BOM.ShowWindow()
	if not InCombatLockdown() then
		BuffOmat_MainWindow:Show()
	end
end

function BOM.WindowVisible()
	return BuffOmat_MainWindow:IsVisible()
end

function BOM.ToggleWindow()
	if BuffOmat_MainWindow:IsVisible() then
		BOM.HideWindow()
	else
		BOM.UpdateScan()
		BOM.ShowWindow()
	end
end


function BOM.SaveWindowPosition()
	BOM.DB.X = BuffOmat_MainWindow:GetLeft()
	BOM.DB.Y = BuffOmat_MainWindow:GetTop()
	BOM.DB.Width = BuffOmat_MainWindow:GetWidth()
	BOM.DB.Height = BuffOmat_MainWindow:GetHeight()
end

function BOM.ResetWindow()
	BuffOmat_MainWindow:ClearAllPoints()
	BuffOmat_MainWindow:SetPoint("Center", UIParent, "Center", 0, 0)
	BuffOmat_MainWindow:SetWidth(200)
	BuffOmat_MainWindow:SetHeight(200)
	BOM.SaveWindowPosition()
	BOM.ShowWindow(1)
end

local function WhoRequest(name)
	DEFAULT_CHAT_FRAME.editBox:SetText("/who " .. name) 
	ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox)
end

local function WhisperRequest(name)
	ChatFrame_OpenChat("/w " .. name .." ")
end

local function Icon(x)
	return string.format(BOM.TxtEscapePicture,x)
end

BOM.IconGreen=Icon("Interface\\COMMON\\Indicator-Green")
BOM.IconRed=Icon("Interface\\COMMON\\Indicator-Red")
BOM.IconNIL=Icon("Interface\\Buttons\\UI-CheckBox-Up")
BOM.IconX=Icon("Interface\\COMMON\\VOICECHAT-MUTED")
--"Interface\\Buttons\\UI-StopButton")
BOM.IconSelfCastOn=Icon("Interface\\FriendsFrame\\UI-Toast-FriendOnlineIcon")
BOM.IconSelfCastOff=Icon("Interface\\FriendsFrame\\UI-Toast-ChatInviteIcon")
BOM.IconTargetOn=Icon("Interface\\CURSOR\\Crosshairs")
BOM.IconTargetOff=Icon("Interface\\Buttons\\UI-MultiCheck-Disabled")
--"Interface\\CURSOR\\UnableCrosshairs")

local function onEnter(self)
	if self._privat_ToolTipLink or self._privat_ToolTipText then
		GameTooltip_SetDefaultAnchor(BuffOmat_MainWindow_Tooltip,UIParent)
		BuffOmat_MainWindow_Tooltip:SetOwner(BuffOmat_MainWindow,"ANCHOR_PRESERVE")
		BuffOmat_MainWindow_Tooltip:ClearLines()
		if self._privat_ToolTipLink then 
			BuffOmat_MainWindow_Tooltip:SetHyperlink(self._privat_ToolTipLink)
		else
			BuffOmat_MainWindow_Tooltip:AddLine(self._privat_ToolTipText)
			if self._privat_Target then
				BuffOmat_MainWindow_Tooltip:AddLine(BOM.lastTarget or L.TTSelectTarget)
			end
		end
		BuffOmat_MainWindow_Tooltip:Show()
	
	
	end
end
local function onLeave(self)
	BuffOmat_MainWindow_Tooltip:Hide()
end

local function RemoveBlessingClass(class)
	for i,spell in ipairs(BOM.Spells) do
		if spell.isBlessing then 
			BOM.DBChar.Spell[spell.ConfigID].Class[class]=false
		end
	end
end

local function onMouseUp(self,button)
	if self._privat_DB and self._privat_Var then
		if self._privat_IsBlessing then
			if self._privat_DB[self._privat_Var] then
				self._privat_DB[self._privat_Var]=false
			else
				RemoveBlessingClass(self._privat_Var)
				self._privat_DB[self._privat_Var]=true
			end
				
		else
			self._privat_DB[self._privat_Var]=not self._privat_DB[self._privat_Var]
		end
		BOM.UpdateSpells()
		BOM.UpdateScan()
	elseif self._privat_DB and self._privat_Target and BOM.lastTarget then
		if self._privat_DB[BOM.lastTarget]==self._privat_set then
			self._privat_DB[BOM.lastTarget]=nil
		else
			self._privat_DB[BOM.lastTarget]=self._privat_set
		end
	
		BOM.UpdateSpells()
		BOM.UpdateScan()	
	end
end


local function CreateBox(icon)
	local FrameInfo=CreateFrame("Frame",nil,BuffOmat_SpellTab_Scroll_Child)
	local FrameInfoText= FrameInfo:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	FrameInfoText:SetPoint("TOPLEFT")
	FrameInfoText:SetText(icon)
	FrameInfo:SetScript("OnEnter",onEnter)
	FrameInfo:SetScript("OnLeave",onLeave)
	FrameInfo:SetScript("OnMouseUp",onMouseUp)
	FrameInfo:SetWidth(FrameInfoText:GetWidth())
	FrameInfo:SetHeight(FrameInfoText:GetHeight())
	FrameInfo:Show()
	return FrameInfo,FrameInfoText
end

local function CreateSpellTab()
	local last
	local isHorde=(UnitFactionGroup("player"))=="Horde"
	
	for i,spell in ipairs(BOM.Spells) do
		if spell.FrameInfo==nil then
			spell.FrameInfo,spell.FrameInfoText= CreateBox(spell.singleLinkIcon)
			spell.FrameInfo._privat_ToolTipLink="spell:"..spell.singleId
		end
		
		if last then
			spell.FrameInfo:SetPoint("TOPLEFT",last,"BOTTOMLEFT",0,-2)
		else
			spell.FrameInfo:SetPoint("TOPLEFT")
		end
		
		local l=spell.FrameInfo
		local dx=2
		
		
		if spell.FrameEnable==nil then
			spell.FrameEnable,spell.FrameEnableText= CreateBox(BOM.IconNIL)
			spell.FrameEnable:SetPoint("TOPLEFT",l,"TOPRIGHT",dx,0)
			spell.FrameEnable._privat_DB=BOM.DBChar.Spell[spell.ConfigID]
			spell.FrameEnable._privat_Var="Enable"
			spell.FrameEnable._privat_ToolTipText=L.TTEnable
			l=spell.FrameEnable
			dx=2
		
					
			if BOM.SpellHasClasses(spell) then	
				spell.FrameSelf,spell.FrameSelfText= CreateBox(BOM.IconNIL)
				spell.FrameSelf:SetPoint("TOPLEFT",l,"TOPRIGHT",dx,0)
				spell.FrameSelf._privat_DB=BOM.DBChar.Spell[spell.ConfigID]
				spell.FrameSelf._privat_Var="SelfCast"
				spell.FrameSelf._privat_ToolTipText=L.TTSelfCast
				
				l=spell.FrameSelf
				dx=2
			
				spell.FrameClasses={}
				spell.FrameClassesText={}
				
				for ci,class in ipairs(BOM.Tool.Classes) do
					spell.FrameClasses[class],spell.FrameClassesText[class]= CreateBox(BOM.IconNIL)
					spell.FrameClasses[class]:SetPoint("TOPLEFT",l,"TOPRIGHT",dx,0)
					spell.FrameClasses[class]._privat_DB=BOM.DBChar.Spell[spell.ConfigID].Class
					spell.FrameClasses[class]._privat_Var=class
					spell.FrameClasses[class]._privat_IsBlessing=spell.isBlessing
					spell.FrameClasses[class]._privat_ToolTipText=BOM.Tool.IconClass[class].." "..BOM.Tool.ClassName[class]
					
					
					if (isHorde and class=="PALADIN") or (not isHorde and class=="SHAMAN") then 
						spell.FrameClasses[class]:Hide()
					else
						l=spell.FrameClasses[class]
						dx=0
					end
				end				
				dx=2
				
				spell.FrameTarget,spell.FrameTargetText= CreateBox(BOM.IconNIL)
				spell.FrameTarget:SetPoint("TOPLEFT",l,"TOPRIGHT",dx,0)
				if spell.isBlessing then
					spell.FrameTarget._privat_DB=BOM.DBChar.Spell[BOM.BLESSINGID]
					spell.FrameTarget._privat_set=spell.ConfigID
				else
					spell.FrameTarget._privat_DB=BOM.DBChar.Spell[spell.ConfigID].ForcedTarget
					spell.FrameTarget._privat_set=true					
				end
				spell.FrameTarget._privat_Target=true
				spell.FrameTarget._privat_ToolTipText=L.TTTarget
				
				
				
				l=spell.FrameTarget
				dx=2
				
			end
			
			
			
		end
		
		last=spell.FrameInfo
	end

end

function BOM.UpdateSpells()
	if BOM.Spells==nil then return end
	if not BOM.CreateSpellTab then
		CreateSpellTab()
		BOM.CreateSpellTab=true
	end
	
	
	for i,spell in ipairs(BOM.Spells) do
		spell.FrameEnableText:SetText(BOM.DBChar.Spell[spell.ConfigID].Enable and BOM.IconGreen or BOM.IconRed)
	
		if BOM.SpellHasClasses(spell) then
			
			spell.FrameSelfText:SetText(BOM.DBChar.Spell[spell.ConfigID].SelfCast and BOM.IconSelfCastOn or BOM.IconSelfCastOff)
			
			for ci,class in ipairs(BOM.Tool.Classes) do
				if BOM.DBChar.Spell[spell.ConfigID].SelfCast then
					spell.FrameClassesText[class]:SetText(BOM.DBChar.Spell[spell.ConfigID].Class[class] and BOM.IconX or BOM.IconNIL)
				else
					spell.FrameClassesText[class]:SetText(BOM.DBChar.Spell[spell.ConfigID].Class[class] and BOM.Tool.IconClass[class] or BOM.IconNIL)
				end
				
				if BOM.lastTarget~=nil then
					if spell.isBlessing then
						spell.FrameTargetText:SetText(BOM.DBChar.Spell[BOM.BLESSINGID][BOM.lastTarget]==spell.ConfigID and BOM.IconTargetOn or BOM.IconTargetOff)
					else
						spell.FrameTargetText:SetText(BOM.DBChar.Spell[spell.ConfigID].ForcedTarget[BOM.lastTarget] and BOM.IconTargetOn or BOM.IconTargetOff)
					end
				else
					spell.FrameTargetText:SetText(BOM.IconX)
				end
			end
			
			
		
		end
		
		--BuffOmat_SpellTab_MessageFrame:AddMessage(txt)
	end
end


function BOM.EnterHyperlink(link,text)
	--print(link,text)
	local part=BOM.Tool.Split(link,":")
	if part[1]=="spell" or part[1]=="unit" then
		GameTooltip_SetDefaultAnchor(BuffOmat_MainWindow_Tooltip,UIParent)
		BuffOmat_MainWindow_Tooltip:SetOwner(BuffOmat_MainWindow,"ANCHOR_PRESERVE")
		BuffOmat_MainWindow_Tooltip:ClearLines()
		BuffOmat_MainWindow_Tooltip:SetHyperlink(link)
		BuffOmat_MainWindow_Tooltip:Show()
	end
end
function BOM.LeaveHyperlink()
	BuffOmat_MainWindow_Tooltip:Hide()
end
function BOM.ClickHyperlink(link)
	local part=BOM.Tool.Split(link,":")
	if part[1]=="unit" then
		if IsShiftKeyDown() then
			WhoRequest(part[3])
			--SendWho( req.name )
		else
			WhisperRequest(part[3])
		end
	end
end


function BOM.DebugBuffs()

	print("LastTracking:",BOM.DBChar.LastTracking," ")
	print("ForceTracking:",BOM.ForceTracking," ")
	print("ActivAura:",BOM.ActivAura," ")
	print("LastAura:",BOM.DBChar.LastAura," ")
	print("ActivSeal:",BOM.ActivSeal," ")
	print("LastSeal:",BOM.DBChar.LastSeal," ")
	print("ActivBlessing:",BOM.ActivBlessing," ")
	print("LastBlessing:",BOM.LastBlessing," ")
	print("Shapeshift:", GetShapeshiftFormID()," ")
	print("name, icon, count, debuffType, duration, expirationTime, source, isStealable, nameplateShowPersonal, spellId, canApplyAura, isBossDebuff, castByPlayer, nameplateShowAll, timeMod")
	for buffIndex=1,40 do
		local val={UnitAura("player", buffIndex,"HELPFUL")}
		if val and (val[1] or val[2] or val[3] or val[4]) then
			print("Help:"..BOM.Tool.Combine(val,", "))
		end
		 
	end
end

